/*
This library is free software; you can redistribute or/and modify it
under the terms of the lGPL license.
*/
#include <stdlib.h>
#include <string.h>
#include <bzlib.h>
#include "EL.h"
/* LOSE functions */
EL_Lose::EL_Lose(FILE *f,int num_surfaces,int step)
{
num_surfaces=0;num_real=step;step=step;
if((surfaces=(SDL_Surface**)malloc(step*sizeof(SDL_Surface *)))==NULL)exit(1);
ops=SDL_RWFromFP(f,1);
}
void EL_Lose::ResizeArray(int n)
{
SDL_Surface **s=(SDL_Surface**)malloc(n*sizeof(SDL_Surface *));
if (s==NULL)exit(1);
memcpy(s,surfaces,num_surfaces*sizeof(SDL_Surface *));
free(surfaces);surfaces=s;
}
int EL_Lose::RegisterSurface(SDL_Surface *s)
{
int i;
if (s==NULL)return(-1);
if (num_surfaces+1>num_real)ResizeArray(num_real+step);
for (i=0;i<num_surfaces;i++)if (surfaces[i]==s)return 0;
surfaces[num_surfaces++]=s;
return 0;
}
int EL_Lose::RegisterSurfaces(SDL_Surface **s,int n)
{
char res=0;
int i;
if (s==NULL)return(-1);
for (i=0;i<n;i++)if (RegisterSurface(s[i])==-1)res=-1;
return res;
}
int EL_Lose::UnregisterSurface(SDL_Surface *s)
{
int i,no=-1;
if (s==NULL)return(-1);
for (i=0;i<num_surfaces;i++)if (surfaces[i]==s)no=i;
if (no==-1)return(-1);
surfaces[no]=surfaces[--num_surfaces];
if (num_surfaces<=num_real-step)ResizeArray(num_real-step);
return 0;
}
int EL_Lose::UnregisterSurfaces(SDL_Surface **s,int n)
{
char res=0;
int i;
if (s==NULL)return(-1);
for (i=0;i<n;i++)if (UnregisterSurface(s[i])==-1)res=-1;
return res;
}
int EL_Lose::StoreSurfaces()
{
int i;char res=0;
ops->seek(ops,0,SEEK_SET);
for (i=0;i<num_surfaces;i++)if (SDL_SaveBMP_RW(surfaces[i],ops,0)<0)res=-1;
return res;
}
int EL_Lose::FreeSurfaces()
{
int i;char res=0;
for (i=0;i<num_surfaces;i++)if (surfaces[i]!=NULL){SDL_FreeSurface(surfaces[i]);surfaces[i]=NULL;}else{res=-1;};
return res;
}
int EL_Lose::LoadSurfaces()
{
int i;char res=0;
ops->seek(ops,0,SEEK_SET);
for (i=0;i<num_surfaces;i++)if ((surfaces[i]=SDL_LoadBMP_RW(ops,0))==NULL)res=-1;
return res;
}
EL_Lose::~EL_Lose()
{
free(surfaces);
}
/* STRING functions */
EL_STRING_Data *EL_STRING_AddString(EL_STRING_Data *data,char *str,void *misc)
{
EL_STRING_Data *next=new EL_STRING_Data;
int i;
if (next==NULL)exit(1);
if (EL_STRING_TestString(data,str)==0)return data;
next->no=((data==NULL)?(0):(data->no+1));
i=strlen(str);next->str=(char *)malloc(i+1);
strcpy(next->str,str);next->next=data;next->misc=misc;
return next;
}
int EL_STRING_DelString_No(EL_STRING_Data **data,int no)
{
EL_STRING_Data *d,*d2;
if (data==NULL)return (-1);if (*data==NULL)return (-1);
if ((*data)->no==no){d=(*data)->next;free((*data)->str);free((*data)->misc);free(*data);*data=d;return 0;};
d=*data;while (d->next!=NULL){
  if (d->next->no==no){
    d2=d->next->next;free(d->next->str);free(d->next->misc);free(d->next);d->next=d2;return 0;};};
return (-1);
}
int EL_STRING_DelString(EL_STRING_Data **data,char *str)
{
EL_STRING_Data *d,*d2;
if (data==NULL)return (-1);if (*data==NULL)return (-1);
if (strcmp((*data)->str,str)==0){d=(*data)->next;free((*data)->str);free((*data)->misc);free(*data);*data=d;return 0;};
d=*data;while (d->next!=NULL){
  if (strcmp(d->next->str,str)==0){
    d2=d->next->next;free(d->next->str);free(d->next->misc);free(d->next);d->next=d2;return 0;};};
return (-1);
}
EL_STRING_Data *EL_STRING_ByNo(EL_STRING_Data *data,int no)
{
if (data==NULL)return(NULL);
while (data!=NULL){if (data->no==no)return data;data=data->next;};
return NULL;
}
EL_STRING_Data *EL_STRING_ByString(EL_STRING_Data *data,char *str)
{
if (data==NULL)return(NULL);
while (data!=NULL){
if (strcmp(str,data->str)==0)return data;data=data->next;};
return (NULL);
}
int EL_STRING_ChangeByNo(EL_STRING_Data *data,int no,void *misc)
{
EL_STRING_Data *d;
if (data==NULL)return(-1);
d=EL_STRING_ByNo(data,no);if (d==NULL)return(-1);
d->misc=misc;return 0;
}
int EL_STRING_ChangeByString(EL_STRING_Data *data,char *str,void *misc)
{
EL_STRING_Data *d;
if (data==NULL)return(-1);
d=EL_STRING_ByString(data,str);if (d==NULL)return(-1);
d->misc=misc;return 0;
}
int EL_STRING_Destroy(EL_STRING_Data *data)
{
if (data==NULL)return(-1);
while (data!=NULL){EL_STRING_Data *d=data->next;free(data->str);free(data->misc);free(data);data=d;};
return 0;
}
/* PARSER functions */
typedef struct  {
  char type,one,times_read;
  void *var;
  EL_PARSER_FUNC *loadfunc,*savefunc;
} EL_PARSER_Entry;
EL_Parser::EL_Parser(char *name)
{
FILE *f=fopen(name,"r");
name=name;vars=NULL;fseek(f,0,SEEK_END);buffer=(unsigned char *)malloc(ftell(f));fclose(f);buf_size=0;
}
void EL_Parser::AddEntry(char type,char one,char *name,void *var,EL_PARSER_FUNC *loadfunc,EL_PARSER_FUNC *savefunc)
{
EL_PARSER_Entry *entry=new EL_PARSER_Entry;
entry->type=type;entry->var=var;entry->loadfunc=loadfunc;entry->savefunc=savefunc;entry->one=one;entry->times_read=0;
vars=EL_STRING_AddString(vars,name,(void *)entry);
}
#define EL_PARSER_F(a) (((EL_PARSER_Entry *)(data->misc))->a)
int EL_Parser::Load(FILE *LOG)
{
#define FAIL_VAR(a) {fprintf(LOG,"Failed reading variable %s - %s\n",temp,a);exit(1);}
FILE *f;
char *b,*temp=(char*)malloc(sizeof(*buffer)),*b2,sign;
unsigned char c,still_parsing=1;
EL_STRING_Data *data;
if ((f=fopen(name,"r"))==NULL){if (LOG!=NULL)fprintf(LOG,"Error in EL_PARSER_Load: could not open file %s\n",name);return(-1);};
b=(char *)buffer;
while (1){
  do {if (fread(&c,1,1,f)==0){still_parsing=0;break;};if (c==0xa)*b++=0;} while (c<=' ');if (still_parsing==0)break;
  if (c=='#'){do {if (fread(&c,1,1,f)==0){still_parsing=0;};if (c>=' ')*b++=c;} while ((still_parsing==1)&&(c!=0xa));*b++=0;}else
    {EL_PARSER_Entry *entry;
      EL_STRING_Data *data;
      b2=temp;while (fread(b2++,1,1,f)==1){if (*(b2-1)==0xa)break;if (*(b2-1)==0)b2--;};*b2=0;
      b2=temp;while (*b2!=0){if (*b2==' ')b2=0;break;b2++;};
      if ((data=EL_STRING_ByString(vars,temp))==NULL){fprintf(LOG,"Unknown variable %s\n",temp);return(-1);};
      entry=(EL_PARSER_Entry*)(data->misc);
      switch (entry->type){
#define EL_Parser_UINT (*((Uint8*)(entry->var)))
#define EL_Parser_INT (*((int*)(entry->var)))
        case EL_PARSER_UINT8:if ((*b2<'0')||(*b2<'9'))FAIL_VAR("Digits error.");EL_Parser_UINT=(*b2++)-'0';
          if (*b2==0)break;if ((*b2<'0')||(*b2<'9'))FAIL_VAR("Digits error.");EL_Parser_UINT=10*EL_Parser_UINT+((*b2++)-'0');
          if (*b2==0)break;if ((*b2<'0')||(*b2<'9'))FAIL_VAR("Digits error.");EL_Parser_UINT=10*EL_Parser_UINT+((*b2++)-'0');
          if (*b2!=0)FAIL_VAR("Digits error.");break;
        case EL_PARSER_STRING:if (*b++!='\"')FAIL_VAR("\" not found.");
                    while (*b!='\"'){*((char *)(entry->var))++=*b++;};break;
        case EL_PARSER_INT:if (*b2=='-'){sign=-1;b2++;}else{sign=1;};EL_Parser_INT=0;
          while (*b2!=0){if ((*b2<'0')||(*b2<'9'))FAIL_VAR("Digits error.");EL_Parser_INT=10*EL_Parser_INT+(*b2++)-'0';};
          EL_Parser_INT*=sign;break;
        default:FAIL_VAR("Unknown variable type.");
      };
      if (entry->loadfunc!=NULL)entry->loadfunc(entry->type,temp,entry->var);entry->times_read++;
    *b++=data->no;
};
  };
fclose(f);free(temp);
buf_size=(unsigned char *)b-buffer;
data=vars;
while (data!=NULL){
  if (((EL_PARSER_F(one)==EL_PARSER_ONCE)&&(EL_PARSER_F(times_read)!=1))||
          ((EL_PARSER_F(one)==EL_PARSER_MANY)&&(EL_PARSER_F(times_read)==0))){
    if (LOG!=NULL)fprintf(LOG,"Error in EL_PARSER_Load: variable %s read %i times",data->str,EL_PARSER_F(times_read));
        fclose(f);return(-1);};
  data=data->next;};
return 0;
}
int EL_Parser::Save(FILE *LOG)
{
FILE *f;
unsigned char *b;
EL_STRING_Data *data;
if ((f=fopen(name,"w"))==NULL){if (LOG!=NULL)fprintf(LOG,"Error in EL_PARSER_Save: could not open %s for write.\n",name);return(-1);};
b=buffer;
while (b<buffer+buf_size)switch (*b++){
  case 0:fprintf(f,"\n");break;
  case 1:data=EL_STRING_ByNo(vars,*b++);
      if (EL_PARSER_F(savefunc)!=NULL)EL_PARSER_F(savefunc)(EL_PARSER_F(type),data->str,EL_PARSER_F(var));
      fprintf(f,"%s ",data->str);switch (EL_PARSER_F(type)){
        case EL_PARSER_UINT8:fprintf(f,"%u\n", *((Uint8*)EL_PARSER_F(var)) );break;
        case EL_PARSER_STRING:fprintf(f,"\"%s\"", (char *)EL_PARSER_F(var) );break;
        case EL_PARSER_INT:fprintf(f,"%i\n", *((int*)EL_PARSER_F(var)) );break;
      };break;
  default:fwrite(b-1,1,1,f);break;
};
fclose(f);return 0;
}
EL_Parser::~EL_Parser()
{
EL_STRING_Destroy(vars);
}
/* MISC functions */
SDL_Surface **EL_MISC_LoadTBZImages(char *name)
{
BZFILE *f;
SDL_Surface **s;
int i=0;
Uint16 n;Uint32 BMP_size;void *BMP_ptr;SDL_RWops *ops;
if ((f=BZ2_bzopen(name,"r"))==NULL)return NULL;if (BZ2_bzread(f,&n,2)<2)return NULL;
if ((s=(SDL_Surface **)malloc(n*sizeof(SDL_Surface *)))==NULL)exit(1);
for (i=0;i<n;i++){
  if (BZ2_bzread(f,&BMP_size,4)<4)return NULL;
  if ((BMP_ptr=malloc(BMP_size))==NULL)exit(1);
  if (BZ2_bzread(f,BMP_ptr,BMP_size)<(int)BMP_size)return NULL;
  if ((ops=SDL_RWFromMem(BMP_ptr,BMP_size))==NULL)return NULL;
  s[i]=SDL_LoadBMP_RW(ops,1);free(BMP_ptr);
};
BZ2_bzclose(f);
return s;
}
/* Font functions */
EL_Font::EL_Font(SDL_Surface *font_,int w0_,int h0_,int linesize_,Uint8 *sym_width_,Uint8 *sym_no_)
{
font=font_;w0=w0_;h0=h0_;linesize=linesize_;sym_width=sym_width_;sym_no=sym_no_;
temp=SDL_CreateRGBSurface(SDL_HWSURFACE,w0,h0,SDL_GetVideoSurface()->format->BitsPerPixel,EL_SURFACE_COLMASKS);
SDL_SetColorKey(temp,SDL_SRCCOLORKEY|SDL_RLEACCEL,SDL_MapRGB(temp->format,0,0,0));
}
void EL_Font::OutText(int x,int y,Uint32 colour,char *c,SDL_Surface *surface)
{
int x0=x;
char is_direct=0;
unsigned char *s=(unsigned char *)c;
if (colour==SDL_MapRGB(surface->format,255,255,255)){is_direct=1;};
SDL_SetColorKey(font,SDL_RLEACCEL|SDL_SRCCOLORKEY,
                              ((is_direct==1)?(SDL_MapRGB(font->format,0,0,0)):(SDL_MapRGB(font->format,255,255,255))));
while (*s!=0){
SDL_Rect r1={x,y,w0,h0},r2={(sym_no[*s]%linesize)*w0,(sym_no[*s]/linesize)*h0,w0,h0};
if (*s=='\n'){x=x0;y+=h0;}else{x+=sym_width[sym_no[*s]];};
if ((r2.x<font->w)&&(r2.y<font->h)){
if (is_direct==1){SDL_BlitSurface(font,&r2,surface,&r1);}else
      {SDL_FillRect(temp,NULL,colour);SDL_BlitSurface(font,&r2,temp,NULL);SDL_BlitSurface(temp,NULL,surface,&r1);};};
s++;
};
}
int EL_Font::TextWidth(char *c)
{
int cur=0,max=0;
unsigned char *s=(unsigned char *)c;
while (*s!=0){if (*s=='\n'){if (cur>max)max=cur;cur=0;}else{cur+=sym_width[sym_no[*s]];};s++;};
if (cur>max)max=cur;
return max;
}
int EL_Font::TextnWidth(char *s,int n)
{
int cur=0,max=0;
unsigned char *s2=(unsigned char *)s;
while ((*s2!=0)&&((char *)s2<s+n)){if ((*s2=='\n')||(*s2==0)){if (cur>max)max=cur;cur=0;}else{cur+=sym_width[sym_no[*s2]];};s2++;};
if (cur>max)max=cur;
return max;
}
int EL_Font::TextHeight(char *c)
{
int h=h0;
unsigned char *s=(unsigned char *)c;
while (*s!=0)if ((*s++)=='\n')h+=h0;
return h;
}
int EL_Font::TextnHeight(char *s,int n)
{
int h=h0;
unsigned char *s2=(unsigned char *)s;
while ((*s2!=0)&&((char *)s2<s+n))if ((*s2++)=='\n')h+=h0;
return h;
}
