/*
This library is free software; you can redistribute or/and modify it
under the terms of the lGPL license.
*/
#include <stdlib.h>
#include "EL.h"
#include <SDL/SDL_keysym.h>
/* functions */
EL_STRING_Data *EL_GUI_Themes=NULL;
EL_GUI_Form *EL_GUI_CurrentForm=NULL;
int EL_GUI_RegisterWidget(char *theme_name,char *widget_name,EL_GUI_WidgetInitFunc *func)
{
EL_STRING_Data *d;
if ((d=EL_STRING_ByString(EL_GUI_Themes,theme_name))==NULL)
  d=EL_GUI_Themes=EL_STRING_AddString(EL_GUI_Themes,theme_name,NULL);
d=(EL_STRING_Data *)(d->misc);
if (EL_STRING_TestString(d,widget_name)==0)return (-1);
d=EL_STRING_AddString(d,widget_name,(void *)func);
EL_STRING_ChangeByString(EL_GUI_Themes,theme_name,d);
return 0;
}
EL_GUI_WidgetInitFunc *EL_GUI_GetWidget (char *theme_name,char *widget_name)
{
EL_STRING_Data *d;
if (EL_STRING_TestString(EL_GUI_Themes,theme_name)==-1)theme_name="default";
d=(EL_STRING_Data *)((EL_STRING_ByString(EL_GUI_Themes,theme_name))->misc);
d=EL_STRING_ByString(d,widget_name);
if (d==NULL){theme_name="default";d=(EL_STRING_Data *)((EL_STRING_ByString(EL_GUI_Themes,"default"))->misc);
  d=EL_STRING_ByString(d,widget_name);};
if (d==NULL){return NULL;}else{return ((EL_GUI_WidgetInitFunc *)(d->misc));};
}
EL_GUI_Form::EL_GUI_Form(EL_GUI_FormHandler *handler_,int xs_,int ys_,Uint32 back_colour_)
{
screen=SDL_GetVideoSurface();x=(screen->w-xs_)/2;y=(screen->h-ys_)/2;xs=xs_;ys=ys_;return_value=-1;handler=handler_;widgets=NULL;
back_colour=back_colour_;form_was_changed=0;
back=SDL_CreateRGBSurface(SDL_HWSURFACE,screen->w,screen->h,screen->format->BitsPerPixel,EL_SURFACE_COLMASKS);
}
void EL_GUI_Form::AddWidget(EL_GUI_Widget *widget)
{
EL_GUI_FormEntry *entry=new EL_GUI_FormEntry;
if (entry==NULL)exit(1);
if (widget==NULL){free(entry);return;};
entry->widget=widget;entry->next=widgets;widgets=entry;
}
void EL_GUI_Form::Refresh(void)
{
SDL_Rect r1={x,y,xs,ys};
EL_GUI_FormEntry *entry;
SDL_BlitSurface(back,NULL,screen,NULL);
SDL_FillRect(screen,&r1,back_colour);
entry=widgets;while (entry!=NULL){entry->widget->refresh();entry=entry->next;};SDL_Flip(screen);
}
int EL_GUI_Form::Proceed(void)
{
EL_GUI_FormEntry *entry;
SDL_Event event;
if ((xs<1)||(ys<1))return (-1);
EL_GUI_CurrentForm=this;return_value=-1;SDL_BlitSurface(screen,NULL,back,NULL);Refresh();
while (return_value==-1)if (SDL_PollEvent(&event))if(event.type==SDL_MOUSEBUTTONDOWN){
  entry=widgets;while (entry!=NULL){if (entry->widget->proceed_click(&(event.button))==0)break;entry=entry->next;};
Refresh();
};
SDL_BlitSurface(back,NULL,screen,NULL);
return return_value;
}
EL_GUI_Form::~EL_GUI_Form()
{
EL_GUI_FormEntry *entry=widgets,*e;
while (entry!=NULL){delete entry->widget;e=entry->next;delete entry;entry=e;};
}
/* GUI string filters */
EL_STRING_Data *EL_GUI_StringFilters=NULL;
EL_GUI_StringFilter *EL_GUI_StringFilterFunc(int smth)
{
return new EL_GUI_StringFilter;
}
void EL_GUI_StringFilter_Uint::create(char *buf)
{
char size=0;
int v=*value;
if (v==0){buf[0]='0';buf[1]=0;return;};
while (v>0){size++;v/=10;};
buf[size--]=0;v=*value;while(size>=0){buf[size--]='0'+v%10;v/=10;};
}
int EL_GUI_StringFilter_Uint::test(char *buf)
{
char *b;
float f;
if (*buf==0){buf[0]='0';buf[1]=0;};
b=buf;while (*b!=0){if ((*b<'0')||(*b>'9'))return -1;b++;};
b=buf;f=0;while (*b!=0)f=f*10+(*b++-'0');
return 0;
}
void EL_GUI_StringFilter_Uint::set(char *buf)
{
*value=0;
char *b=buf;
while (*b!=0)*value=*value*10+((*b++)-'0');
if ((*value<min)||(*value>max)){if (*value<min)*value=min;if (*value>max)*value=max;create(buf);};
}
EL_GUI_StringFilter *EL_GUI_StringFilter_UintFunc(int min,int max,int *value)
{
EL_GUI_StringFilter_Uint *f=new EL_GUI_StringFilter_Uint;
f->min=min;f->max=max;f->value=value;
return f;
}
int EL_GUI_RegisterStringFilter(char *filter_name,EL_GUI_StringFilterInitFunc *func)
{
if (EL_STRING_TestString(EL_GUI_StringFilters,filter_name)==0){return -1;}else{
EL_GUI_StringFilters=EL_STRING_AddString(EL_GUI_StringFilters,filter_name,(void *)func);return 0;};
}
EL_GUI_StringFilterInitFunc *EL_GUI_GetStringFilter(char *filter_name)
{
return (EL_GUI_StringFilterInitFunc*)(EL_STRING_ByString(EL_GUI_StringFilters,filter_name)->misc);
}
void EL_GUI_RegisterStandartStringFilters(void)
{
EL_GUI_RegisterStringFilter("uint",(EL_GUI_StringFilterInitFunc *)(&EL_GUI_StringFilter_UintFunc));
EL_GUI_RegisterStringFilter("none",(EL_GUI_StringFilterInitFunc *)(&EL_GUI_StringFilterFunc));

}
/* widgets */
#define EL_GUI_X0 (EL_GUI_CurrentForm->x)
#define EL_GUI_Y0 (EL_GUI_CurrentForm->y)
#define EL_GUI_SCRN (EL_GUI_CurrentForm->screen)
static void EL_GUI_WaitForUnclick(void)
{
SDL_Event event;
while (1)if (SDL_PollEvent(&event))if(event.type==SDL_MOUSEBUTTONUP)return;
}
int EL_GUI_OutwinCloseWidget::proceed_click(SDL_MouseButtonEvent *click)
{
if ((click->x<EL_GUI_X0)||(click->y<EL_GUI_Y0)||
    (click->x>EL_GUI_X0+EL_GUI_CurrentForm->xs)||(click->y>EL_GUI_Y0+EL_GUI_CurrentForm->ys))
      {EL_GUI_CurrentForm->return_value=0;return 0;};
return -1;
}
EL_GUI_Widget *EL_GUI_OutwinCloseWidgetFunc(int x,int y,void *nothing)
{
EL_GUI_OutwinCloseWidget *w=new EL_GUI_OutwinCloseWidget;
return w;
}
void EL_GUI_TextWidget::refresh()
{
font->OutText(x+EL_GUI_X0,y+EL_GUI_Y0,colour,text,EL_GUI_SCRN);
}
EL_GUI_Widget *EL_GUI_TextWidgetFunc(int x,int y,EL_Font *font,char *text,Uint32 colour)
{
EL_GUI_TextWidget *w=new EL_GUI_TextWidget;
w->x=x;w->y=y;w->font=font;w->text=text;w->colour=colour;return w;
}
int EL_GUI_ButtonWidget::proceed_click(SDL_MouseButtonEvent *click)
{
int x=click->x-EL_GUI_X0,y=click->y-EL_GUI_Y0;
if ((x>=x1)&&(x<=x2)&&(y>=y1)&&(y<=y2)){
  if ((EL_GUI_SCRN->flags&SDL_DOUBLEBUF)!=0)EL_GUI_CurrentForm->Refresh();
  show(0);SDL_Flip(EL_GUI_SCRN);if (event!=-1)EL_GUI_CurrentForm->handler(event,info);EL_GUI_WaitForUnclick();return 0;
}else{return -1;};
}
void EL_GUI_ButtonWidget::show(char is_norm)
{
SDL_Rect r1={EL_GUI_X0+x1,EL_GUI_Y0+y1,x2-x1,1},r2={EL_GUI_X0+x1+1,EL_GUI_Y0+y2,x2-x1,1},
                 r3={EL_GUI_X0+x1,EL_GUI_Y0+y1,1,y2-y1},r4={EL_GUI_X0+x2,EL_GUI_Y0+y1+1,1,y2-y1};
SDL_FillRect(EL_GUI_SCRN,&r1,(is_norm==1)?(dark):(light));SDL_FillRect(EL_GUI_SCRN,&r2,(is_norm==1)?(light):(dark));
SDL_FillRect(EL_GUI_SCRN,&r3,(is_norm==1)?(dark):(light));SDL_FillRect(EL_GUI_SCRN,&r4,(is_norm==1)?(light):(dark));
}
void EL_GUI_ButtonWidget::refresh()
{
show(1);
}
EL_GUI_Widget *EL_GUI_ButtonWidgetFunc(int x1,int y1,int x2,int y2,Uint32 light,Uint32 dark,int event,int info)
{
EL_GUI_ButtonWidget *w=new EL_GUI_ButtonWidget;
w->x1=x1;w->y1=y1;w->x2=x2;w->y2=y2;w->dark=dark;w->light=light;w->event=event;w->info=info;
return w;
}
void EL_GUI_ImageWidget::refresh()
{
SDL_Rect r1=rect,r2={EL_GUI_X0+x,EL_GUI_Y0+y,rect.w,rect.h};
SDL_BlitSurface(image,&r1,EL_GUI_SCRN,&r2);
}
EL_GUI_Widget *EL_GUI_ImageWidgetFunc(int x,int y,SDL_Rect r,SDL_Surface *s)
{
EL_GUI_ImageWidget *w=new EL_GUI_ImageWidget;
w->x=x;w->y=y;w->rect=r;w->image=s;
return w;
}
void EL_GUI_TransparentWidget::refresh()
{
SDL_Rect r1={EL_GUI_X0+x,EL_GUI_Y0+y,xs,ys};
SDL_BlitSurface(EL_GUI_CurrentForm->back,&r1,EL_GUI_SCRN,&r1);
}
EL_GUI_Widget *EL_GUI_TransparentWidgetFunc(int x,int y,int xs,int ys)
{
EL_GUI_TransparentWidget *w=new EL_GUI_TransparentWidget;
w->x=x;w->y=y;w->xs=xs;w->ys=ys;
return w;
}
void EL_GUI_BorderWidget::refresh()
{
SDL_Rect r1[4]={
{EL_GUI_X0,EL_GUI_Y0,1,EL_GUI_CurrentForm->ys},
{EL_GUI_X0,EL_GUI_Y0,EL_GUI_CurrentForm->xs,1},
{EL_GUI_X0+EL_GUI_CurrentForm->xs-1,EL_GUI_Y0,1,EL_GUI_CurrentForm->ys},
{EL_GUI_X0,EL_GUI_Y0+EL_GUI_CurrentForm->ys-1,EL_GUI_CurrentForm->xs,1}},
r2[4]={
{r1[0].x+1,r1[0].y+1,1,r1[0].h-2},
{r1[1].x+1,r1[1].y+1,r1[1].w-2,1},
{r1[2].x-1,r1[2].y+1,1,r1[2].h-2},
{r1[3].x+1,r1[3].y-1,r1[3].w-2,1}};
int i;
for (i=0;i<4;i++)SDL_FillRect(EL_GUI_SCRN,&(r1[i]),colours[0]);
for (i=0;i<4;i++)SDL_FillRect(EL_GUI_SCRN,&(r2[i]),colours[1]);
}
EL_GUI_Widget *EL_GUI_BorderWidgetFunc(int x,int y,Uint32 col1,Uint32 col2)
{
EL_GUI_BorderWidget *w=new EL_GUI_BorderWidget;
w->colours[0]=col1;w->colours[1]=col2;
return w;
}
int EL_GUI_HeaderWidget::proceed_click(SDL_MouseButtonEvent *click)
{
SDL_Event event;
char was_moved,unclick=0;
int dx,dy;
if ((click->x<EL_GUI_X0+x1)||(click->x>EL_GUI_X0+x2)||(click->y<EL_GUI_Y0)||(click->y>EL_GUI_Y0+size))return -1;
SDL_GetMouseState(&dx,&dy);dx=EL_GUI_X0-dx;dy=EL_GUI_Y0-dy;
while (unclick==0){
was_moved=0;
while(SDL_PollEvent(&event))switch(event.type){case SDL_MOUSEMOTION:was_moved=1;break;case SDL_MOUSEBUTTONUP:unclick=1;break;};
if (was_moved==1){EL_GUI_X0=event.motion.x+dx;EL_GUI_Y0=event.motion.y+dy;EL_GUI_CurrentForm->Refresh();};
};
return 0;
}
void EL_GUI_HeaderWidget::refresh()
{
SDL_Rect r1={EL_GUI_X0+x1,EL_GUI_Y0,x2-x1,size};
SDL_FillRect(EL_GUI_SCRN,&r1,colour);
}
EL_GUI_Widget *EL_GUI_HeaderWidgetFunc(int x1,int x2,Uint32 colour,char size)
{
EL_GUI_HeaderWidget *w=new EL_GUI_HeaderWidget;
w->colour=colour;w->size=size;w->x1=x1;w->x2=x2;
return w;
}
int EL_GUI_CloseButtonWidget::proceed_click(SDL_MouseButtonEvent *click)
{
if ((click->x>=EL_GUI_X0+x)&&(click->y>=EL_GUI_Y0+y)&&(click->x<=EL_GUI_X0+x+size)&&(click->y<=EL_GUI_Y0+y+size)){
    if (event!=-1)EL_GUI_CurrentForm->handler(event,info);EL_GUI_CurrentForm->return_value=resault;EL_GUI_WaitForUnclick();return 0;};
return -1;
}
void EL_GUI_CloseButtonWidget::refresh()
{
SDL_Rect r1={EL_GUI_X0+x,EL_GUI_Y0+y,size,size},r2={r1.x+1,r1.y+1,size-2,size-2},rc={r1.x+size/2,r1.y+size/2,1,1},
    r3[4]={{(r1.x+rc.x)/2,(r1.y+rc.y)/2,1,1},{(r1.x+rc.x+size)/2,(r1.y+rc.y)/2,1,1},
    {(r1.x+rc.x)/2,(r1.y+rc.y+size)/2,1,1},{(r1.x+rc.x+size)/2,(r1.y+rc.y+size)/2,1,1}};
int i;
SDL_FillRect(EL_GUI_SCRN,&r1,SDL_MapRGB(EL_GUI_SCRN->format,0,0,0));
SDL_FillRect(EL_GUI_SCRN,&r2,SDL_MapRGB(EL_GUI_SCRN->format,255,255,255));
SDL_FillRect(EL_GUI_SCRN,&rc,SDL_MapRGB(EL_GUI_SCRN->format,0,0,0));
for(i=0;i<4;i++)SDL_FillRect(EL_GUI_SCRN,&(r3[i]),SDL_MapRGB(EL_GUI_SCRN->format,0,0,0));
}
EL_GUI_Widget *EL_GUI_CloseButtonWidgetFunc(int x,int y,char size,int event,int info,int resault)
{
EL_GUI_CloseButtonWidget *w=new EL_GUI_CloseButtonWidget;
w->x=x;w->y=y;w->size=size;w->event=event;w->info=info;w->resault=resault;
return w;
}
void EL_GUI_CloseButtonWidget_Nice::refresh()
{
SDL_Rect r1=r,r2={EL_GUI_X0+x,EL_GUI_Y0+y,r1.w,r1.h};
SDL_BlitSurface(s,&r1,EL_GUI_SCRN,&r2);
}
EL_GUI_Widget *EL_GUI_CloseButtonWidget_NiceFunc(int x,int y,char size,int event,int info,int resault,SDL_Rect r,SDL_Surface *s)
{
EL_GUI_CloseButtonWidget_Nice *w=new EL_GUI_CloseButtonWidget_Nice;
w->x=x;w->y=y;w->size=size;w->event=event;w->info=info;w->resault=resault;w->r=r;w->s=s;
return w;
}
void EL_GUI_StringChoiceWidget::show_table(int y0,char ch)
{
int i,h=font->TextHeight(" ");
for (i=0;i<n;i++){
SDL_Rect r1={EL_GUI_X0+x,y0+h*i,font->TextWidth(str[i]),h};
SDL_FillRect(EL_GUI_SCRN,&r1,cols[(i!=ch)?(0):(2)]);
font->OutText(EL_GUI_X0+x,y0+h*i,cols[1],str[i],EL_GUI_SCRN);
};
}
int EL_GUI_StringChoiceWidget::proceed_click(SDL_MouseButtonEvent *click)
{
int h=font->TextHeight(" "),y0=EL_GUI_Y0+y-(h*n)/2,i;
char ch_old=*choice,ch=*choice+1,is_double=((EL_GUI_SCRN->flags&SDL_DOUBLEBUF)!=0)?(1):(0),still_chosing=1;
SDL_Event event;
if ((click->x<EL_GUI_X0+x)||(click->y<EL_GUI_Y0+y)||(click->x>EL_GUI_X0+x+font->TextWidth(str[*choice]))||
                            (click->y>EL_GUI_Y0+y+font->TextHeight(str[*choice])))return -1;
if (y0<0)y0=0;if(y0>EL_GUI_SCRN->h-n*h)y0=EL_GUI_SCRN->h-n*h;
show_table(y0,*choice);SDL_Flip(EL_GUI_SCRN);
if (is_double==1){EL_GUI_CurrentForm->Refresh();show_table(y0,*choice);SDL_Flip(EL_GUI_SCRN);};
while (still_chosing==1){
if (SDL_PollEvent(&event))switch(event.type){
case SDL_MOUSEMOTION:if ((event.motion.x<EL_GUI_X0+x)||(event.motion.y<y0)||(event.motion.y>=y0+n*h)){ch=-1;}else
  {if (event.motion.x>EL_GUI_X0+x+font->TextWidth(str[(event.motion.y-y0)/h])){ch=-1;}else{ch=(event.motion.y-y0)/h;};};break;
case SDL_MOUSEBUTTONUP:if (ch==-1)ch=*choice;still_chosing=0;break;
};
if (ch_old!=ch)for (i=0;i<=is_double;i++){show_table(y0,ch);SDL_Flip(EL_GUI_SCRN);};ch_old=ch;
};
*choice=ch;
return -1;
}
void EL_GUI_StringChoiceWidget::refresh()
{
SDL_Rect r1={EL_GUI_X0+x,EL_GUI_Y0+y,font->TextWidth(str[*choice]),font->TextHeight(str[*choice])};
SDL_FillRect(EL_GUI_SCRN,&r1,cols[0]);
font->OutText(EL_GUI_X0+x,EL_GUI_Y0+y,cols[1],str[*choice],EL_GUI_SCRN);
}
EL_GUI_Widget *EL_GUI_StringChoiceWidgetFunc(int x,int y,char n,char **str,EL_Font *font_,Uint32 textcol,Uint32 backcol,Uint32 shcol,char *choice_)
{
EL_GUI_StringChoiceWidget *w=new EL_GUI_StringChoiceWidget;
w->x=x;w->y=y;w->n=n;w->str=str;w->font=font_;w->cols[0]=backcol;w->cols[1]=textcol;w->cols[2]=shcol;w->choice=choice_;
return w;
}
int EL_GUI_StringEditWidget::proceed_click(SDL_MouseButtonEvent *click)
{
int h=font->TextHeight(" "),i;
char is_double=(EL_GUI_SCRN->flags&SDL_DOUBLEBUF)/SDL_DOUBLEBUF,still_editing=1,cursor=0,n=0,*buf2=(char *)malloc(size);
Uint32 last_ticks;
SDL_Event event;
if ((click->x<x+EL_GUI_X0)||(click->y<y+EL_GUI_Y0)||(click->x>x+EL_GUI_X0+font->TextWidth(buf))||
                                  (click->y>y+EL_GUI_Y0+font->TextHeight(buf)))return -1;
if (is_double==1)EL_GUI_CurrentForm->Refresh();
last_ticks=SDL_GetTicks();
while (still_editing==1){
if (SDL_GetTicks()>last_ticks+ticks){cursor=1-cursor;last_ticks+=ticks;for (i=0;i<1+is_double;i++){
  SDL_Rect r1={EL_GUI_X0+x+font->TextnWidth(buf,n),EL_GUI_Y0+y,1,h},r2={EL_GUI_X0+x,EL_GUI_Y0+y,xs,font->TextHeight(buf)};
  SDL_FillRect(EL_GUI_SCRN,&r2,cols[0]);font->OutText(EL_GUI_X0+x,EL_GUI_Y0+y,cols[1],buf,EL_GUI_SCRN);
                                        SDL_FillRect(EL_GUI_SCRN,&r1,cols[cursor]);SDL_Flip(EL_GUI_SCRN);};};
if (SDL_PollEvent(&event))if(event.type==SDL_KEYUP){
  memcpy(buf2,buf,size);
  switch(event.key.keysym.sym){
    case SDLK_RETURN:case SDLK_ESCAPE:filter->set(buf);still_editing=0;break;
    case SDLK_LEFT:if (n!=0)n--;break;
    case SDLK_RIGHT:if (n!=(char)strlen(buf))n++;break;
    case SDLK_UNKNOWN:case SDLK_TAB:case SDLK_CLEAR:case SDLK_PAUSE:break;
    case SDLK_DELETE:if (n==(char)strlen(buf))break;memcpy(&(buf2[n]),&(buf2[n+1]),size-n-1);if (filter->test(buf2)==0){memcpy(buf,buf2,size);}
                    else{memcpy(buf2,buf,size);};break;
    case SDLK_BACKSPACE:if (n==0)break;memcpy(&(buf2[n-1]),&(buf2[n]),size-n);if (filter->test(buf2)==0){memcpy(buf,buf2,size);n--;}
                    else{memcpy(buf2,buf,size);};break;
    default:if ((event.key.keysym.sym<SDLK_UP)&&((char)strlen(buf)<size-1)){
for (i=size-1;i>n;i--)buf2[i]=buf2[i-1];buf2[n]=event.key.keysym.sym;
                                                                if (filter->test(buf2)==0){memcpy(buf,buf2,size);n++;}else{memcpy(buf2,buf,size);};};break;
};};};
free(buf2);return 0;
}
void EL_GUI_StringEditWidget::refresh()
{
SDL_Rect r1={EL_GUI_X0+x,EL_GUI_Y0+y,xs,font->TextHeight(buf)};
SDL_FillRect(EL_GUI_SCRN,&r1,cols[0]);
font->OutText(EL_GUI_X0+x,EL_GUI_Y0+y,cols[1],buf,EL_GUI_SCRN);
}
EL_GUI_Widget *EL_GUI_StringEditWidgetFunc(int x,int y,int xs,char size,char *buf,Uint32 textcol,Uint32 backcol,int ticks,EL_Font *font,
                                                                                  EL_GUI_StringFilter *filter)
{
EL_GUI_StringEditWidget *w=new EL_GUI_StringEditWidget;
w->x=x;w->y=y;w->xs=xs;w->size=size;w->buf=buf;w->cols[0]=backcol;w->cols[1]=textcol;w->ticks=ticks;w->font=font;w->filter=filter;
w->filter->create(w->buf);
return w;
}
int EL_GUI_SlayerWidget::proceed_click(SDL_MouseButtonEvent *click)
{
SDL_Event event;
char still_changing=1;
if ((click->x<EL_GUI_X0+x)||(click->x>=EL_GUI_X0+x+im_size)||(click->y<EL_GUI_Y0+y-d)||(click->y>=EL_GUI_Y0+y+d+2))return -1;
if((EL_GUI_SCRN->flags&SDL_DOUBLEBUF)!=0)EL_GUI_CurrentForm->Refresh();
while (still_changing==1)if(SDL_PollEvent(&event))switch(event.type){
case SDL_MOUSEBUTTONUP:still_changing=0;break;
case SDL_MOUSEMOTION:if ((event.motion.x>=EL_GUI_X0+x)||(event.motion.x<EL_GUI_X0+x+im_size)||
  (event.motion.y>=EL_GUI_Y0+y-d)||(event.motion.y<EL_GUI_Y0+y+d+2)){
  SDL_Rect r1={EL_GUI_X0+x,EL_GUI_Y0+y-d,im_size+1,2*d+3},r2=r1;
    *n=((event.motion.x-EL_GUI_X0-x)*(size-1))/(im_size-1);if (*n<0)*n=0;if(*n>=size)*n=size-1;
  SDL_FillRect(EL_GUI_SCRN,&r1,EL_GUI_CurrentForm->back_colour);refresh();SDL_Flip(EL_GUI_SCRN);
  if((EL_GUI_SCRN->flags&SDL_DOUBLEBUF)!=0){refresh();SDL_FillRect(EL_GUI_SCRN,&r2,EL_GUI_CurrentForm->back_colour);
                  SDL_Flip(EL_GUI_SCRN);};};break;
};
return 0;
}
void EL_GUI_SlayerWidget::refresh()
{
SDL_Rect r1={EL_GUI_X0+x,EL_GUI_Y0+y,im_size,1},r2={r1.x,r1.y+1,r1.w,1};
SDL_Rect r3={EL_GUI_X0+x+(*n*(im_size-1))/(size-1),EL_GUI_Y0+y-d,1,2*d+3},r4={r3.x+1,r3.y,1,r3.h};
SDL_FillRect(EL_GUI_SCRN,&r1,cols[0]);SDL_FillRect(EL_GUI_SCRN,&r2,cols[1]);
SDL_FillRect(EL_GUI_SCRN,&r3,cols[0]);SDL_FillRect(EL_GUI_SCRN,&r4,cols[1]);
}
EL_GUI_Widget *EL_GUI_SlayerWidgetFunc(int x,int y,int size,int im_size,int *n,char d,Uint32 lightcol,Uint32 darkcol)
{
EL_GUI_SlayerWidget *w=new EL_GUI_SlayerWidget;
w->x=x;w->y=y;w->size=size;w->im_size=im_size;w->n=n;w->d=d;w->cols[0]=lightcol;w->cols[1]=darkcol;
return w;
}
void EL_GUI_RadioButtonsWidget::show_one(int n,char state)
{
SDL_Rect r1={EL_GUI_X0+x,EL_GUI_Y0+y+n*step,size,size};
SDL_FillRect(EL_GUI_SCRN,&r1,SDL_MapRGB(EL_GUI_SCRN->format,255*(1-state),255*state,0));
}
int EL_GUI_RadioButtonsWidget::proceed_click(SDL_MouseButtonEvent *click)
{
if ((click->x<EL_GUI_X0+x)||(click->y<EL_GUI_Y0+y)||(click->x>=EL_GUI_X0+x+size)||(click->y>=EL_GUI_Y0+y+step*no))return -1;
if (((click->y-EL_GUI_Y0-y)%step)>=size)return -1;
*curr=(click->y-EL_GUI_Y0-y)/step;return 0;
}
void EL_GUI_RadioButtonsWidget::refresh()
{
int i;
for (i=0;i<no;i++)show_one(i,(i==*curr)?(1):(0));
}
EL_GUI_Widget *EL_GUI_RadioButtonsWidgetFunc(int x,int y,int no,char *curr,int step,int size)
{
EL_GUI_RadioButtonsWidget *w=new EL_GUI_RadioButtonsWidget;
w->x=x;w->y=y;w->no=no;w->curr=curr;w->step=step;w->size=size;
return w;
}
void EL_GUI_RadioButtonsWidget_Nice::show_one(int n,char state)
{
SDL_Rect r1={EL_GUI_X0+x,EL_GUI_Y0+y+n*step,size,size},r2=rects[state];
SDL_BlitSurface(surfaces[state],&r2,EL_GUI_SCRN,&r1);
}
EL_GUI_Widget *EL_GUI_RadioButtonsWidgetFunc_Nice(int x,int y,int no,char *curr,int step,int size,SDL_Surface *dis_s,SDL_Rect dis_r,
                                            SDL_Surface *en_s,SDL_Rect en_r)
{
EL_GUI_RadioButtonsWidget_Nice *w=new EL_GUI_RadioButtonsWidget_Nice;
w->x=x;w->y=y;w->no=no;w->curr=curr;w->step=step;w->size=size;w->surfaces[0]=dis_s;w->surfaces[1]=en_s;
w->rects[0]=dis_r;w->rects[1]=en_r;
return w;
}
void EL_GUI_CheckButtonsWidget::show_one(int n,char state)
{
SDL_Rect r1={EL_GUI_X0+x,EL_GUI_Y0+y+n*step,size,size};
SDL_FillRect(EL_GUI_SCRN,&r1,SDL_MapRGB(EL_GUI_SCRN->format,255*(1-state),255*state,0));
}
int EL_GUI_CheckButtonsWidget::proceed_click(SDL_MouseButtonEvent *click)
{
if ((click->x<EL_GUI_X0+x)||(click->y<EL_GUI_Y0+y)||(click->x>=EL_GUI_X0+x+size)||(click->y>=EL_GUI_Y0+y+step*no))return -1;
if (((click->y-EL_GUI_Y0-y)%step)>=size)return -1;
buttons[(click->y-EL_GUI_Y0-y)/step]^=1;return 0;
}
void EL_GUI_CheckButtonsWidget::refresh()
{
int i;
for (i=0;i<no;i++)show_one(i,buttons[i]);
}
EL_GUI_Widget *EL_GUI_CheckButtonsWidgetFunc(int x,int y,int no,char *buttons,int step,int size)
{
EL_GUI_CheckButtonsWidget *w=new EL_GUI_CheckButtonsWidget;
w->x=x;w->y=y;w->no=no;w->buttons=buttons;w->step=step;w->size=size;
return w;
}
void EL_GUI_CheckButtonsWidget_Nice::show_one(int n,char state)
{
SDL_Rect r1={EL_GUI_X0+x,EL_GUI_Y0+y+n*step,size,size},r2=rects[state];
SDL_BlitSurface(surfaces[state],&r2,EL_GUI_SCRN,&r1);
}
EL_GUI_Widget *EL_GUI_CheckButtonsWidgetFunc_Nice(int x,int y,int no,char *buttons,int step,int size,SDL_Surface *dis_s,SDL_Rect dis_r,
                                            SDL_Surface *en_s,SDL_Rect en_r)
{
EL_GUI_CheckButtonsWidget_Nice *w=new EL_GUI_CheckButtonsWidget_Nice;
w->x=x;w->y=y;w->no=no;w->buttons=buttons;w->step=step;w->size=size;w->surfaces[0]=dis_s;w->surfaces[1]=en_s;
w->rects[0]=dis_r;w->rects[1]=en_r;
return w;
}
void EL_GUI_RegisterStandartWidgets(void)
{
EL_GUI_RegisterWidget("default","outwin_close",((EL_GUI_WidgetInitFunc*)(&EL_GUI_OutwinCloseWidgetFunc)));
EL_GUI_RegisterWidget("default","text",((EL_GUI_WidgetInitFunc*)(&EL_GUI_TextWidgetFunc)));
EL_GUI_RegisterWidget("default","button",((EL_GUI_WidgetInitFunc*)(&EL_GUI_ButtonWidgetFunc)));
EL_GUI_RegisterWidget("default","image",((EL_GUI_WidgetInitFunc*)(&EL_GUI_ImageWidgetFunc)));
EL_GUI_RegisterWidget("default","transparent",((EL_GUI_WidgetInitFunc*)(&EL_GUI_TransparentWidgetFunc)));
EL_GUI_RegisterWidget("default","border",((EL_GUI_WidgetInitFunc*)(&EL_GUI_BorderWidgetFunc)));
EL_GUI_RegisterWidget("default","header",((EL_GUI_WidgetInitFunc*)(&EL_GUI_HeaderWidgetFunc)));
EL_GUI_RegisterWidget("default","closebutton",((EL_GUI_WidgetInitFunc*)(&EL_GUI_CloseButtonWidgetFunc)));
EL_GUI_RegisterWidget("nice","closebutton",((EL_GUI_WidgetInitFunc*)(&EL_GUI_CloseButtonWidget_NiceFunc)));
EL_GUI_RegisterWidget("default","stringchoice",((EL_GUI_WidgetInitFunc*)(&EL_GUI_StringChoiceWidgetFunc)));
EL_GUI_RegisterWidget("default","stringedit",((EL_GUI_WidgetInitFunc*)(&EL_GUI_StringEditWidgetFunc)));
EL_GUI_RegisterWidget("default","slayer",((EL_GUI_WidgetInitFunc*)(&EL_GUI_SlayerWidgetFunc)));
EL_GUI_RegisterWidget("default","radiobuttons",((EL_GUI_WidgetInitFunc*)(&EL_GUI_RadioButtonsWidgetFunc)));
EL_GUI_RegisterWidget("nice","radiobuttons",((EL_GUI_WidgetInitFunc*)(&EL_GUI_RadioButtonsWidgetFunc_Nice)));
EL_GUI_RegisterWidget("default","checkbuttons",((EL_GUI_WidgetInitFunc*)(&EL_GUI_CheckButtonsWidgetFunc)));
EL_GUI_RegisterWidget("nice","checkbuttons",((EL_GUI_WidgetInitFunc*)(&EL_GUI_CheckButtonsWidgetFunc_Nice)));

}
